<?php
/**
 * @package		Joomla.Site
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

/* The following line loads the MooTools JavaScript Library */
JHtml::_('behavior.framework', true);

/* The following line gets the application object for things like displaying the site name */
$app = JFactory::getApplication();
?>
<?php echo '<?'; ?>xml version="1.0" encoding="<?php echo $this->_charset ?>"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>" >
	<head>
		<!-- The following JDOC Head tag loads all the header and meta information from your site config and content. -->
		<jdoc:include type="head" />

		<!-- The following five lines load the Blueprint CSS Framework (http://blueprintcss.org). If you don't want to use this framework, delete these lines. -->
		<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/blueprint/screen.css" type="text/css" media="screen, projection" />
		<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/blueprint/print.css" type="text/css" media="print" />
		<!--[if lt IE 8]><link rel="stylesheet" href="blueprint/ie.css" type="text/css" media="screen, projection"><![endif]-->
		<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/blueprint/plugins/fancy-type/screen.css" type="text/css" media="screen, projection" />
		<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/blueprint/plugins/joomla-nav/screen.css" type="text/css" media="screen" />

		<!-- The following line loads the template CSS file located in the template folder. -->
		<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/template.css" type="text/css" />

		<!-- The following four lines load the Blueprint CSS Framework and the template CSS file for right-to-left languages. If you don't want to use these, delete these lines. -->
		<?php if($this->direction == 'rtl') : ?>
			<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/blueprint/plugins/rtl/screen.css" type="text/css" />
			<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/template_rtl.css" type="text/css" />
		<?php endif; ?>

		<!-- The following line loads the template JavaScript file located in the template folder. It's blank by default. -->
		<script type="text/javascript" src="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/js/template.js"></script>
        <script type="text/javascript" src="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/js/cufon-yui.js"></script>
		<script type="text/javascript" src="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/js/Barkentina_1_400.font.js"></script>
		<script type="text/javascript">// <![CDATA[
	Cufon.replace('.menu a');
// ]]></script>
	</head>
	<body>
    <div id="menu_ext">
    <div id="mainbody">
    <?php if($this->countModules('logo')) : ?><div id="logo"><jdoc:include type="modules" name="logo" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('menu')) : ?><div id="menu"><jdoc:include type="modules" name="menu" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('busca')) : ?><div id="busca"><jdoc:include type="modules" name="busca" style="xhtml" /></div><?php endif; ?>
    </div>
    </div>
    
    <?php if($this->countModules('slide')) : ?><div id="slide2"></div><div id="slide"><div id="fundo-slide"></div><jdoc:include type="modules" name="slide" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('topo')) : ?><div id="topo_fora"><div id="mainbody"><div id="topo"><jdoc:include type="modules" name="topo" style="xhtml" /></div></div></div><?php endif; ?>
    
    <?php if($this->countModules('cases-home')) : ?><div id="bg-home"><div id="mainbody"><div id="cases-home"><jdoc:include type="modules" name="cases-home" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('institucional')) : ?><div id="institucional"><jdoc:include type="modules" name="institucional" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('servicos')) : ?><div id="servicos"><jdoc:include type="modules" name="servicos" style="xhtml" /></div><?php endif; ?>
    </div>
    </div>
    <div id="mainbody">
    <?php if($this->countModules('breadcrumbs')) : ?><div id="breadcrumbs"><jdoc:include type="modules" name="breadcrumbs" style="xhtml" /></div><?php endif; ?>
    
    <?php if( JRequest::getVar( 'view' ) == 'frontpage' ) { ?><jdoc:include type="component" /><?php } else { ?>
    <jdoc:include type="message" />
	<div id="conteudo"><jdoc:include type="component" /></div>
    <?php } ?>
    <?php if($this->countModules('cases')) : ?><div id="cases"><jdoc:include type="modules" name="cases" style="xhtml" /></div><?php endif; ?>
    
	<?php if($this->countModules('azul')) : ?><div id="azul"><jdoc:include type="modules" name="azul" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('fotos')) : ?><div id="fotos"><jdoc:include type="modules" name="fotos" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('missao')) : ?><div id="missao"><jdoc:include type="modules" name="missao" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('visao')) : ?><div id="visao"><jdoc:include type="modules" name="visao" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('valores')) : ?><div id="valores"><jdoc:include type="modules" name="valores" style="xhtml" /></div><?php endif; ?>
       
    </div>
    <?php if($this->countModules('espaco')) : ?><div id="espaco"><jdoc:include type="modules" name="espaco" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('mapa')) : ?><div id="footer_top"></div><div id="footer"><div id="mainbody"><div id="mapa"><jdoc:include type="modules" name="mapa" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('clientes')) : ?><div id="clientes"><jdoc:include type="modules" name="clientes" style="xhtml" /></div><?php endif; ?>
    <?php if($this->countModules('contato')) : ?><div id="contato"><jdoc:include type="modules" name="contato" style="xhtml" /></div><?php endif; ?>
    </div>
    </div>
    <?php if($this->countModules('footer2')) : ?><div id="footer2"><div id="mainbody"><jdoc:include type="modules" name="footer2" style="xhtml" /><?php endif; ?>
    </div>
    </div>

	</body>
			
</html>
